//
// This file was generated by the JavaTM Architecture for XML Binding(JAXB) Reference Implementation, vhudson-jaxb-ri-2.1-833 
// See <a href="http://java.sun.com/xml/jaxb">http://java.sun.com/xml/jaxb</a> 
// Any modifications to this file will be lost upon recompilation of the source schema. 
// Generated on: 2013.01.07 at 09:26:44 AM CET 
//


package nl.cloudfarming.client.isobus.model;

import java.util.ArrayList;
import java.util.List;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlID;
import javax.xml.bind.annotation.XmlIDREF;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlType;
import javax.xml.bind.annotation.adapters.CollapsedStringAdapter;
import javax.xml.bind.annotation.adapters.XmlJavaTypeAdapter;


/**
 * 
 * Type: Task data
 * 
 * Description:
 * The Task XML element describes an ISO 11783 task. The task is the central XML element in the data transfer
 * file. It contains references to various other XML elements to express allocation of resources and specification
 * of operations.
 * By specifying the XML attributes CustomerIdRef, FarmIdRef and PartfieldIdRef in a task, redundant relations
 * between task, customer, farm and partfield can be created. This redundancy is allowed and shall not result in
 * conflicts in the relations between these XML elements.
 * The XML attribute ResponsibleWorkerIdRef is a reference to a single worker responsible for this task. This
 * can, for example, be the worker that specified this task or a worker that can be contacted to provide additional
 * detail about this task. The recording of, for example, start time and duration of one or more workers
 * contributing to execution of a task shall be done by the use of XML element WorkerAllocation in a task.
 * Multiple WorkerAllocation XML elements can be specified in a single task.
 * 
 * References XML elements:
 * - Customer
 * - Farm
 * - Partfield
 * - (Responsible) Worker
 * - (Default and PositionLost) TreatmentZones
 * 
 * Includes XML elements:
 * - TreatmentZone
 * - Time
 * - OperTechPractice
 * - WorkerAllocation
 * - DeviceAllocation
 * - Connection
 * - ProductAllocation
 * - DataLogTrigger
 * - CommentAllocation
 * - Grid
 * - TimeLog
 *                 
 * 
 * 
 * 
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "", propOrder = {
    "cnn",
    "dan",
    "dlt",
    "grd",
    "otp",
    "pan",
    "tim",
    "tlg",
    "tzn",
    "wan",
    "can"
})
@XmlRootElement(name = "TSK")
public class IsobusTask {

    @XmlElement(name = "CNN")
    protected List<Connection> cnn;
    @XmlElement(name = "DAN")
    protected List<DeviceAllocation> dan;
    @XmlElement(name = "DLT")
    protected List<DataLog> dlt;
    @XmlElement(name = "GRD")
    protected IsobusGrid grd;
    @XmlElement(name = "OTP")
    protected OperationTechniquePractice otp;
    @XmlElement(name = "PAN")
    protected List<ProductAllocation> pan;
    @XmlElement(name = "TIM")
    protected List<IsobusTime> tim;
    @XmlElement(name = "TLG")
    protected List<TimeLog> tlg;
    @XmlElement(name = "TZN")
    protected List<IsobusTreatmentZone> tzn;
    @XmlElement(name = "WAN")
    protected List<WorkerAllocation> wan;
    @XmlElement(name = "CAN")
    protected List<CommentAllocation> can;
    @XmlAttribute(name = "A", required = true)
    @XmlJavaTypeAdapter(CollapsedStringAdapter.class)
    @XmlID
    protected String taskId;
    @XmlAttribute(name = "B")
    protected String taskDesignator;
    @XmlAttribute(name = "C")
    @XmlIDREF
    protected Object customerIdRef;
    @XmlAttribute(name = "D")
    @XmlIDREF
    protected Object farmIdRef;
    @XmlAttribute(name = "E")
    @XmlIDREF
    protected Object partfieldIdRef;
    @XmlAttribute(name = "F")
    @XmlIDREF
    protected Object responsibleWorkerIdRef;
    @XmlAttribute(name = "G", required = true)
    protected IsobusTaskStatusEnum taskStatus;
    @XmlAttribute(name = "H")
    protected Short defaultTreatmentZoneCode;
    @XmlAttribute(name = "I")
    protected Short positionLostTreatmentZoneCode;
    @XmlAttribute(name = "J")
    protected Short outOfFieldTreatmentZoneCode;

    /**
     * Gets the value of the cnn property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the JAXB object.
     * This is why there is not a <CODE>set</CODE> method for the cnn property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getCNN().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link Connection }
     * 
     * 
     */
    public List<Connection> getCNN() {
        if (cnn == null) {
            cnn = new ArrayList<Connection>();
        }
        return this.cnn;
    }

    /**
     * Gets the value of the dan property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the JAXB object.
     * This is why there is not a <CODE>set</CODE> method for the dan property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getDAN().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link DeviceAllocation }
     * 
     * 
     */
    public List<DeviceAllocation> getDAN() {
        if (dan == null) {
            dan = new ArrayList<DeviceAllocation>();
        }
        return this.dan;
    }

    /**
     * Gets the value of the dlt property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the JAXB object.
     * This is why there is not a <CODE>set</CODE> method for the dlt property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getDLT().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link DataLog }
     * 
     * 
     */
    public List<DataLog> getDLT() {
        if (dlt == null) {
            dlt = new ArrayList<DataLog>();
        }
        return this.dlt;
    }

    /**
     * Gets the value of the grd property.
     * 
     * @return
     *     possible object is
     *     {@link IsobusGrid }
     *     
     */
    public IsobusGrid getGRD() {
        return grd;
    }

    /**
     * Sets the value of the grd property.
     * 
     * @param value
     *     allowed object is
     *     {@link IsobusGrid }
     *     
     */
    public void setGRD(IsobusGrid value) {
        this.grd = value;
    }

    /**
     * Gets the value of the otp property.
     * 
     * @return
     *     possible object is
     *     {@link OperationTechniquePractice }
     *     
     */
    public OperationTechniquePractice getOTP() {
        return otp;
    }

    /**
     * Sets the value of the otp property.
     * 
     * @param value
     *     allowed object is
     *     {@link OperationTechniquePractice }
     *     
     */
    public void setOTP(OperationTechniquePractice value) {
        this.otp = value;
    }

    /**
     * Gets the value of the pan property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the JAXB object.
     * This is why there is not a <CODE>set</CODE> method for the pan property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getPAN().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link ProductAllocation }
     * 
     * 
     */
    public List<ProductAllocation> getPAN() {
        if (pan == null) {
            pan = new ArrayList<ProductAllocation>();
        }
        return this.pan;
    }

    /**
     * Gets the value of the tim property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the JAXB object.
     * This is why there is not a <CODE>set</CODE> method for the tim property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getTIM().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link IsobusTime }
     * 
     * 
     */
    public List<IsobusTime> getTIM() {
        if (tim == null) {
            tim = new ArrayList<IsobusTime>();
        }
        return this.tim;
    }

    /**
     * Gets the value of the tlg property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the JAXB object.
     * This is why there is not a <CODE>set</CODE> method for the tlg property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getTLG().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link TimeLog }
     * 
     * 
     */
    public List<TimeLog> getTLG() {
        if (tlg == null) {
            tlg = new ArrayList<TimeLog>();
        }
        return this.tlg;
    }

    /**
     * Gets the value of the tzn property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the JAXB object.
     * This is why there is not a <CODE>set</CODE> method for the tzn property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getTZN().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link IsobusTreatmentZone }
     * 
     * 
     */
    public List<IsobusTreatmentZone> getTZN() {
        if (tzn == null) {
            tzn = new ArrayList<IsobusTreatmentZone>();
        }
        return this.tzn;
    }

    /**
     * Gets the value of the wan property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the JAXB object.
     * This is why there is not a <CODE>set</CODE> method for the wan property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getWAN().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link WorkerAllocation }
     * 
     * 
     */
    public List<WorkerAllocation> getWAN() {
        if (wan == null) {
            wan = new ArrayList<WorkerAllocation>();
        }
        return this.wan;
    }

    /**
     * Gets the value of the can property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the JAXB object.
     * This is why there is not a <CODE>set</CODE> method for the can property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getCAN().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link CommentAllocation }
     * 
     * 
     */
    public List<CommentAllocation> getCAN() {
        if (can == null) {
            can = new ArrayList<CommentAllocation>();
        }
        return this.can;
    }

    /**
     * 
     * Unique identifier of task
     * Format: (TSK|TSK-)([0-9])+
     * Records generated on MICS have negative IDs
     *                         
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getTaskId() {
        return taskId;
    }

    /**
     * Sets the value of the taskId property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setTaskId(String value) {
        this.taskId = value;
    }

    /**
     * 
     * No Description.
     *                         
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getTaskDesignator() {
        return taskDesignator;
    }

    /**
     * Sets the value of the taskDesignator property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setTaskDesignator(String value) {
        this.taskDesignator = value;
    }

    /**
     * 
     * Reference to XML element Customer
     * Format: (CTR|CTR-)([0-9])+  
     *                         
     * 
     * @return
     *     possible object is
     *     {@link Object }
     *     
     */
    public Object getCustomerIdRef() {
        return customerIdRef;
    }

    /**
     * Sets the value of the customerIdRef property.
     * 
     * @param value
     *     allowed object is
     *     {@link Object }
     *     
     */
    public void setCustomerIdRef(Object value) {
        this.customerIdRef = value;
    }

    /**
     * 
     * Reference to XML element Farm
     * Format: (FRM|FRM-)([0-9])+  
     *                         
     * 
     * @return
     *     possible object is
     *     {@link Object }
     *     
     */
    public Object getFarmIdRef() {
        return farmIdRef;
    }

    /**
     * Sets the value of the farmIdRef property.
     * 
     * @param value
     *     allowed object is
     *     {@link Object }
     *     
     */
    public void setFarmIdRef(Object value) {
        this.farmIdRef = value;
    }

    /**
     * 
     * Reference to XML element Partfield
     * Format: (PFD|PFD-)([0-9])+
     *                         
     * 
     * @return
     *     possible object is
     *     {@link Object }
     *     
     */
    public Object getPartfieldIdRef() {
        return partfieldIdRef;
    }

    /**
     * Sets the value of the partfieldIdRef property.
     * 
     * @param value
     *     allowed object is
     *     {@link Object }
     *     
     */
    public void setPartfieldIdRef(Object value) {
        this.partfieldIdRef = value;
    }

    /**
     * 
     * Reference to XML element Worker
     * Format: (WKR|WKR-)([0-9])+  
     *                         
     * 
     * @return
     *     possible object is
     *     {@link Object }
     *     
     */
    public Object getResponsibleWorkerIdRef() {
        return responsibleWorkerIdRef;
    }

    /**
     * Sets the value of the responsibleWorkerIdRef property.
     * 
     * @param value
     *     allowed object is
     *     {@link Object }
     *     
     */
    public void setResponsibleWorkerIdRef(Object value) {
        this.responsibleWorkerIdRef = value;
    }

    /**
     * 
     * Status of the task, possible values:
     *  1 = initial
     *  2 = running
     *  3 = paused
     *  4 = finished
     *                         
     * 
     * @return
     *     possible object is
     *     {@link IsobusTaskStatusEnum }
     *     
     */
    public IsobusTaskStatusEnum getTaskStatus() {
        return taskStatus;
    }

    /**
     * Sets the value of the taskStatus property.
     * 
     * @param value
     *     allowed object is
     *     {@link IsobusTaskStatusEnum }
     *     
     */
    public void setTaskStatus(IsobusTaskStatusEnum value) {
        this.taskStatus = value;
    }

    /**
     * 
     * Reference to XML element TreatmentZone        
     *                         
     * 
     * @return
     *     possible object is
     *     {@link Short }
     *     
     */
    public Short getDefaultTreatmentZoneCode() {
        return defaultTreatmentZoneCode;
    }

    /**
     * Sets the value of the defaultTreatmentZoneCode property.
     * 
     * @param value
     *     allowed object is
     *     {@link Short }
     *     
     */
    public void setDefaultTreatmentZoneCode(Short value) {
        this.defaultTreatmentZoneCode = value;
    }

    /**
     * 
     * Reference to XML element TreatmentZone    
     *                         
     * 
     * @return
     *     possible object is
     *     {@link Short }
     *     
     */
    public Short getPositionLostTreatmentZoneCode() {
        return positionLostTreatmentZoneCode;
    }

    /**
     * Sets the value of the positionLostTreatmentZoneCode property.
     * 
     * @param value
     *     allowed object is
     *     {@link Short }
     *     
     */
    public void setPositionLostTreatmentZoneCode(Short value) {
        this.positionLostTreatmentZoneCode = value;
    }

    /**
     * 
     * Reference to XML element TreatmentZone
     *                         
     * 
     * @return
     *     possible object is
     *     {@link Short }
     *     
     */
    public Short getOutOfFieldTreatmentZoneCode() {
        return outOfFieldTreatmentZoneCode;
    }

    /**
     * Sets the value of the outOfFieldTreatmentZoneCode property.
     * 
     * @param value
     *     allowed object is
     *     {@link Short }
     *     
     */
    public void setOutOfFieldTreatmentZoneCode(Short value) {
        this.outOfFieldTreatmentZoneCode = value;
    }

}
